CamelMimeFilterBestenc
3
CAMEL Library

# CamelMimeFilterBestenc

## Synopsis

    enum                CamelBestencRequired;
    enum                CamelBestencEncoding;
    struct              CamelMimeFilterBestenc;
    CamelMimeFilterBestenc * camel_mime_filter_bestenc_new  (guint flags);
    CamelTransferEncoding  camel_mime_filter_bestenc_get_best_encoding
                                                            (CamelMimeFilterBestenc *filter,
                                                             CamelBestencEncoding required);
    const gchar *       camel_mime_filter_bestenc_get_best_charset
                                                            (CamelMimeFilterBestenc *filter);
    void                camel_mime_filter_bestenc_set_flags (CamelMimeFilterBestenc *filter,
                                                             guint flags);

## Description

## Details

### enum CamelBestencRequired

    typedef enum _CamelBestencRequired {
    	CAMEL_BESTENC_GET_ENCODING = 1<<0,
    	CAMEL_BESTENC_GET_CHARSET = 1<<1,

    	/* do we treat 'lf' as if it were crlf? */
    	CAMEL_BESTENC_LF_IS_CRLF = 1<<8,
    	/* do we not allow "From " to appear at the start of a line in any part? */
    	CAMEL_BESTENC_NO_FROM = 1<<9
    } CamelBestencRequired;

### enum CamelBestencEncoding

    typedef enum _CamelBestencEncoding {
    	CAMEL_BESTENC_7BIT,
    	CAMEL_BESTENC_8BIT,
    	CAMEL_BESTENC_BINARY,

    	/* is the content stream to be treated as text? */
    	CAMEL_BESTENC_TEXT = 1<<8
    } CamelBestencEncoding;

### struct CamelMimeFilterBestenc

    struct CamelMimeFilterBestenc {
    	CamelMimeFilter parent;

    	guint flags;	/* our creation flags, see above */

    	guint count0;	/* count of NUL characters */
    	guint count8;	/* count of 8 bit characters */
    	guint total;	/* total characters read */

    	guint lastc;	/* the last character read */
    	gint crlfnoorder;	/* if crlf's occured where they shouldn't have */

    	gint startofline;	/* are we at the start of a new line? */

    	gint fromcount;
    	gchar fromsave[6];	/* save a few characters if we found an \n near the end of the buffer */
    	gint hadfrom;		/* did we encounter a "\nFrom " in the data? */

    	guint countline;	/* current count of characters on a given line */
    	guint maxline;	/* max length of any line */

    	CamelCharset charset;	/* used to determine the best charset to use */
    };

### camel_mime_filter_bestenc_new ()

    CamelMimeFilterBestenc * camel_mime_filter_bestenc_new  (guint flags);

Create a new CamelMimeFilterBestenc object.

`flags` :

  a bitmask of data required.

Returns :

  a new CamelMimeFilterBestenc object

### camel_mime_filter_bestenc_get_best_encoding ()

    CamelTransferEncoding  camel_mime_filter_bestenc_get_best_encoding
                                                            (CamelMimeFilterBestenc *filter,
                                                             CamelBestencEncoding required);

Get the best encoding, given specific constraints, that can be used to encode a stream of bytes.

`filter` :

  a CamelMimeFilterBestenc object

`required` :

  maximum level of output encoding allowed.

Returns :

  the best encoding to use

### camel_mime_filter_bestenc_get_best_charset ()

    const gchar *       camel_mime_filter_bestenc_get_best_charset
                                                            (CamelMimeFilterBestenc *filter);

Gets the best charset that can be used to contain this content.

`filter` :

  a CamelMimeFilterBestenc object

Returns :

  the name of the best charset to use to encode the input text filtered by `filter`

### camel_mime_filter_bestenc_set_flags ()

    void                camel_mime_filter_bestenc_set_flags (CamelMimeFilterBestenc *filter,
                                                             guint flags);

Set the flags for subsequent operations.

`filter` :

  a CamelMimeFilterBestenc object

`flags` :

  bestenc filter flags